import { defineComponent as _, computed as g, inject as v, openBlock as c, createElementBlock as p, Fragment as m, createElementVNode as n, normalizeStyle as F, withModifiers as w, unref as y, normalizeClass as C, toDisplayString as V, renderList as H, createBlock as f, pushScopeId as I, popScopeId as k, ref as h, provide as u, onMounted as T } from "vue";
const B = (e) => (I("data-v-1a281426"), e = e(), k(), e), L = /* @__PURE__ */ B(() => /* @__PURE__ */ n("g", { id: "caret-down" }, [
  /* @__PURE__ */ n("path", {
    id: "Vector",
    d: "M11.6646 4H2.33542C2.0556 4 1.89936 4.29436 2.07264 4.49531L6.73723 9.88431C6.87074 10.0386 7.12784 10.0386 7.26277 9.88431L11.9274 4.49531C12.1006 4.29436 11.9444 4 11.6646 4Z",
    fill: "#B8B8B8"
  })
], -1)), Z = [
  L
], b = /* @__PURE__ */ B(() => /* @__PURE__ */ n("svg", {
  width: "14",
  height: "14",
  viewBox: "0 0 14 14",
  fill: "none",
  xmlns: "http://www.w3.org/2000/svg"
}, [
  /* @__PURE__ */ n("g", { id: "Folder" }, [
    /* @__PURE__ */ n("path", {
      id: "Vector",
      d: "M12.52 3.66055H7.135L5.3755 1.90742C5.35311 1.88559 5.32367 1.87332 5.293 1.87305H1.48C1.2145 1.87305 1 2.09648 1 2.37305V11.623C1 11.8996 1.2145 12.123 1.48 12.123H12.52C12.7855 12.123 13 11.8996 13 11.623V4.16055C13 3.88398 12.7855 3.66055 12.52 3.66055ZM11.92 10.998H2.08V2.99805H4.9075L6.7015 4.78555H11.92V10.998Z",
      fill: "#4A4A66"
    })
  ])
], -1)), x = { class: "name" }, j = /* @__PURE__ */ _({
  __name: "FolderItem",
  props: {
    folder: {}
  },
  setup(e) {
    const l = e, t = g(() => ({
      paddingLeft: `${l.folder.level * 20}px`
    })), s = v("toggleFolder");
    return (o, r) => (c(), p(m, null, [
      n("div", {
        class: "folder-item yt-file-tree",
        style: F(t.value),
        onClick: r[0] || (r[0] = w((i) => y(s)(o.folder), ["stop"]))
      }, [
        (c(), p("svg", {
          class: C([[o.folder.isOpen ? "open" : "close", o.folder.children.length > 0 ? "" : "hide"], "up-down menu-icon"]),
          width: "14",
          height: "14",
          viewBox: "0 0 14 14",
          fill: "none",
          xmlns: "http://www.w3.org/2000/svg"
        }, Z, 2)),
        b,
        n("div", x, [
          n("span", null, V(o.folder.name), 1)
        ])
      ], 4),
      (c(!0), p(m, null, H(o.folder.isOpen ? o.folder.children : [], (i, d) => (c(), f(A, {
        key: "TreeItem-" + d + "level-" + o.folder.level,
        item: i
      }, null, 8, ["item"]))), 128))
    ], 64));
  }
});
const $ = (e, l) => {
  const t = e.__vccOpts || e;
  for (const [s, o] of l)
    t[s] = o;
  return t;
}, D = /* @__PURE__ */ $(j, [["__scopeId", "data-v-1a281426"]]), z = (e) => (I("data-v-2199b34e"), e = e(), k(), e), E = ["onClick"], N = /* @__PURE__ */ z(() => /* @__PURE__ */ n("svg", {
  width: "14",
  height: "14",
  class: "file-icon",
  viewBox: "0 0 14 14",
  fill: "none",
  xmlns: "http://www.w3.org/2000/svg"
}, [
  /* @__PURE__ */ n("g", { id: "iframe" }, [
    /* @__PURE__ */ n("path", {
      id: "Vector",
      d: "M12.52 1H1.48001C1.21451 1 1.00001 1.2145 1.00001 1.48V12.52C1.00001 12.7855 1.21451 13 1.48001 13H12.52C12.7855 13 13 12.7855 13 12.52V1.48C13 1.2145 12.7855 1 12.52 1ZM2.08001 2.08H4.12001V11.92H2.08001V2.08ZM11.92 11.92H5.08001V5.08H11.92V11.92ZM5.08001 4.12V2.08H11.92V4.12H5.08001Z",
      fill: "#4A4A66"
    })
  ])
], -1)), q = { class: "name" }, G = /* @__PURE__ */ _({
  __name: "FileItem",
  props: {
    file: {}
  },
  setup(e) {
    const l = e, t = g(() => ({
      paddingLeft: `${l.file.level * 20 + 30}px`
    })), s = v("setActiveFile"), o = () => {
      s(l.file.id);
    };
    return (r, i) => (c(), p("div", {
      class: "file-item yt-file-tree",
      style: F(t.value),
      onClick: w(o, ["stop"])
    }, [
      N,
      n("div", q, [
        n("span", null, V(r.file.name), 1)
      ])
    ], 12, E));
  }
});
const J = /* @__PURE__ */ $(G, [["__scopeId", "data-v-2199b34e"]]), A = /* @__PURE__ */ _({
  __name: "TreeItem",
  props: {
    item: {}
  },
  setup(e) {
    const l = v("activeFile");
    return (t, s) => t.item.isFolder ? (c(), f(D, {
      key: 0,
      folder: t.item
    }, null, 8, ["folder"])) : (c(), f(J, {
      key: 1,
      file: t.item,
      class: C({ active: y(l).has(t.item.id) })
    }, null, 8, ["file", "class"]));
  }
}), M = (e, l = !1, t = 0, s = 0) => {
  const o = [];
  for (const r of e) {
    const { id: i, name: d, isFolder: a } = r;
    a ? o.push(
      Object.assign(r, {
        id: i,
        name: d,
        isFolder: a,
        level: t,
        isOpen: l,
        parentId: s,
        children: M(r.children, l, t + 1, r.id)
      })
    ) : o.push(
      Object.assign(r, {
        id: i,
        level: t,
        name: d,
        parentId: s,
        isFolder: a
      })
    );
  }
  return o;
}, O = (e, l, t) => {
  for (const s of e)
    if (s.id === t)
      for (const o of Object.keys(l))
        s[o] = l[o];
    else
      s.isFolder && O(s.children, l, t);
}, K = /* @__PURE__ */ _({
  __name: "Tree",
  props: {
    treeData: {},
    defaultFile: {},
    expandAll: { type: Boolean }
  },
  setup(e) {
    const l = e, t = h([]), s = h(/* @__PURE__ */ new Set([]));
    l.defaultFile && (s.value = /* @__PURE__ */ new Set([l.defaultFile]));
    const o = (i) => {
      O(t.value, { isOpen: !i.isOpen }, i.id);
    };
    return u("setActiveFile", (i) => {
      s.value = /* @__PURE__ */ new Set([i]);
    }), u("activeFile", s), u("toggleFolder", o), T(() => {
      t.value = M(l.treeData);
    }), (i, d) => (c(!0), p(m, null, H(t.value, (a, S) => (c(), f(A, {
      key: "TreeItem-" + S,
      item: a
    }, null, 8, ["item"]))), 128));
  }
}), Q = {
  install: (e) => {
    e.component("Tree", K);
  }
};
export {
  K as Tree,
  Q as default
};
